'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _toConsumableArray2 = require('babel-runtime/helpers/toConsumableArray');

var _toConsumableArray3 = _interopRequireDefault(_toConsumableArray2);

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _class, _temp, _initialiseProps;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _d = require('d3');

var d3 = _interopRequireWildcard(_d);

var _simulation = require('./simulation');

var _simulation2 = _interopRequireDefault(_simulation);

var _node = require('./node');

var _node2 = _interopRequireDefault(_node);

var _link = require('./link');

var _link2 = _interopRequireDefault(_link);

var _default = require('./default');

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var D3ReactForce = (_temp = _class = function (_React$Component) {
  (0, _inherits3.default)(D3ReactForce, _React$Component);

  function D3ReactForce(props) {
    (0, _classCallCheck3.default)(this, D3ReactForce);

    var _this = (0, _possibleConstructorReturn3.default)(this, (D3ReactForce.__proto__ || (0, _getPrototypeOf2.default)(D3ReactForce)).call(this, props));

    _initialiseProps.call(_this);

    var nodes = props.nodes,
        links = props.links,
        staticLayout = props.staticLayout;

    _this.nodesDom = {};
    _this.linksDom = {};
    _this.force = new _simulation2.default(props);
    _this.force.setNodesLinks(nodes, links);
    return _this;
  }

  (0, _createClass3.default)(D3ReactForce, [{
    key: 'componentWillMount',
    value: function componentWillMount() {
      this.force.initDrag();
    }
  }, {
    key: 'componentDidMount',
    value: function componentDidMount() {
      var _this2 = this;

      if (!this.props.staticLayout) {
        this.force.initZoom({
          zoom: function zoom(transform) {
            d3.select(_this2.outg).attr('transform', 'translate(' + transform.translate + ')scale(' + transform.scale + ')');
          }
        });
        d3.select(this.svg).call(this.force.zoom);
      }
      this.force.tick({
        tick: this.tick,
        end: this.props.end
      });
    }
  }, {
    key: 'componentWillReceiveProps',
    value: function componentWillReceiveProps(nextProps) {
      var nodes = nextProps.nodes,
          links = nextProps.links;

      this.force.setSimulationLayout(nextProps);
      this.force.setNodesLinks(nodes, links);
    }
    // 居中

  }, {
    key: 'adaption',
    value: function adaption() {
      var offset = this.outg.getBBox();
      var _props = this.props,
          width = _props.width,
          height = _props.height;
      var _force = this.force,
          translate = _force.translate,
          scale = _force.scale;

      var factor = 1,
          translateX = 0,
          translateY = 0;
      if (offset.width > width || offset.height > height) {
        if (offset.width / width > offset.height / height) {
          factor = (width - 20) / offset.width;
        } else {
          factor = (height - 20) / offset.height;
        }
      }
      var minX = offset.x * scale + translate[0];
      var minY = offset.y * scale + translate[1];
      var outgWidth = offset.width * scale;
      var outgHeight = offset.height * scale;
      var outgCenter = [minX + outgWidth / 2, minY + outgHeight / 2];
      var _translate = [width / 2 - outgCenter[0], height / 2 - outgCenter[1]];
      translateX = translate[0] + _translate[0];
      translateY = translate[1] + _translate[1];
      var svg = d3.select(this.svg);
      if (translateX && translateY && factor) {
        this.force.zoom.transform(svg, d3.zoomIdentity.translate(translateX, translateY).scale(factor));
        this.force.setTransform([translateX, translateY], factor);
        d3.select(this.outg).attr('transform', 'translate(' + this.force.translate + ')scale(' + this.force.scale + ')');
      }
    }
  }, {
    key: 'render',
    value: function render() {
      var _this3 = this;

      var _props2 = this.props,
          width = _props2.width,
          height = _props2.height,
          nodeIdKey = _props2.nodeIdKey,
          staticLayout = _props2.staticLayout;
      var _force2 = this.force,
          translate = _force2.translate,
          scale = _force2.scale,
          nodes = _force2.nodes,
          links = _force2.links;

      var staticLayoutTransform = {};
      if (staticLayout) {
        var getStaticLayoutTransform = this.getStaticLayoutTransform();
        width = getStaticLayoutTransform.width;
        height = getStaticLayoutTransform.height;
        translate = getStaticLayoutTransform.translate;
        scale = getStaticLayoutTransform.scale;
      }
      return _react2.default.createElement(
        'div',
        null,
        _react2.default.createElement(
          'svg',
          { ref: function ref(svg) {
              return _this3.svg = svg;
            }, width: width, height: height },
          _react2.default.createElement(
            'g',
            { ref: function ref(outg) {
                return _this3.outg = outg;
              }, transform: 'translate(' + translate + ')scale(' + scale + ')' },
            _react2.default.createElement(
              'g',
              null,
              links.map(function (link, i) {
                var _key_ = link.source[nodeIdKey] + '_' + link.target[nodeIdKey];
                return _react2.default.createElement(_link2.default, { key: _key_, parentComponment: _this3, addRef: function addRef(c) {
                    _this3.linksDom[_key_] = c;
                  }, link: link });
              })
            ),
            _react2.default.createElement(
              'g',
              null,
              nodes.map(function (node, i) {
                var _key_ = node[nodeIdKey];
                return _react2.default.createElement(_node2.default, { key: _key_, parentComponment: _this3, addRef: function addRef(c) {
                    _this3.nodesDom[_key_] = c;
                  }, node: node });
              })
            )
          ),
          this.props.children
        )
      );
    }
  }]);
  return D3ReactForce;
}(_react2.default.Component), _class.defaultProps = {
  nodes: [],
  links: [],
  width: _default.WIDTH,
  height: _default.HEIGHT,
  nodeIdKey: _default.NODE_ID_KEY,
  velocityDecay: _default.VELOCITY_DECAY,
  linkDistance: _default.LINK_DISTANCE,
  collideRadius: _default.COLLIDE_RADIUS,
  collideStrength: _default.COLLIDE_STRENGTH,
  chargeStrength: _default.CHARGE_STRENGTH,
  staticLayout: false,
  XYCenter: _default.XY_CENTER,
  tick: _default.noop,
  end: _default.noop
}, _initialiseProps = function _initialiseProps() {
  var _this4 = this;

  this.tick = function (alpha) {
    var _props3 = _this4.props,
        nodeIdKey = _props3.nodeIdKey,
        tick = _props3.tick,
        staticLayout = _props3.staticLayout,
        end = _props3.end;
    var force = _this4.force;
    var _force3 = _this4.force,
        nodes = _force3.nodes,
        links = _force3.links;

    if (tick) {
      tick(alpha);
    }
    if (!staticLayout) {
      nodes.forEach(function (node) {
        d3.select(_this4.nodesDom[node[nodeIdKey]]).attr('transform', function () {
          return 'translate(' + node.x + ',' + node.y + ')';
        });
      });
      links.forEach(function (link) {
        d3.select(_this4.linksDom[link.source[nodeIdKey] + '_' + link.target[nodeIdKey]]).attr('x1', function () {
          return force.nodesMap[link.source[nodeIdKey]].x;
        }).attr('y1', function () {
          return force.nodesMap[link.source[nodeIdKey]].y;
        }).attr('x2', function () {
          return force.nodesMap[link.target[nodeIdKey]].x;
        }).attr('y2', function () {
          return force.nodesMap[link.target[nodeIdKey]].y;
        });
      });
    }
  };

  this.getStaticLayoutTransform = function () {
    var _props4 = _this4.props,
        nodes = _props4.nodes,
        width = _props4.width,
        padding = _props4.padding;

    var nodesX = nodes.map(function (node) {
      return node.x;
    });
    var nodesY = nodes.map(function (node) {
      return node.y;
    });
    var minX = Math.min.apply(Math, (0, _toConsumableArray3.default)(nodesX)),
        minY = Math.min.apply(Math, (0, _toConsumableArray3.default)(nodesY)),
        maxX = Math.max.apply(Math, (0, _toConsumableArray3.default)(nodesX)),
        maxY = Math.max.apply(Math, (0, _toConsumableArray3.default)(nodesY));
    var graphWidth = maxX - minX,
        graphHeight = maxY - minY;
    var scale = width > graphWidth ? 1 : width / graphWidth;
    var translateX = scale * minX,
        translateY = scale * minY;
    return {
      width: graphWidth * scale + 2 * padding,
      height: graphHeight * scale + 2 * padding,
      translate: [-translateX + padding, -translateY + padding],
      scale: scale,
      graphWidth: graphWidth,
      graphHeight: graphHeight
    };
  };
}, _temp);


D3ReactForce.Simulation = _simulation2.default;
D3ReactForce.Node = _node2.default;
D3ReactForce.Link = _link2.default;
exports.default = D3ReactForce;
//# sourceMappingURL=index.js.map